setlocal enabledelayedexpansion

@ECHO OFF
REM THE PHANTOM PAIN - S++ Soldiers Patch
REM by ThunderPeel2001 (www.thunderpeel2001.com)
REM Version 1.09a (15 MAY 16)

SET _originalFileSize=238726144
SET _targetFileSize=238726144

CLS

ECHO ===============================================
ECHO THE PHANTOM PAIN - S++ Soldiers Patch for v1.09
ECHO ===============================================
ECHO by ThunderPeel2001 (15 MAY 16) Version 1.09a
ECHO.
ECHO This patch adds S+ and S++ into the single player game world. Note: It will only work with v1.09 of TPP. 
ECHO.
ECHO MORE INFORMATION
ECHO ================
ECHO The soldiers will appear slowly like other soldier ranks, so not to break the game progression. The first S+ soldiers will begin to appear when you reach Level 64. The first S++ soldiers will appear when you reach level 74.
ECHO.

PAUSE

IF NOT EXIST "00.dat" (

  ECHO ERROR: Cannot find 00.dat

  IF NOT EXIST "vpatch.exe" (
    ECHO ERROR: Cannot find vpatch.exe
  )

  ECHO.
  ECHO ABORTING: One or more necessary files are missing. You must run this patch from the ^<game directory^>\MASTER\0\ folder
  ECHO For example: C:\Program Files\Steam\SteamApps\common\MGS_TPP\master\0\ -- just copy the files there and run this script again

  PAUSE

  EXIT

) ELSE (

  IF NOT EXIST "vpatch.exe" (
    ECHO ERROR: Cannot find vpatch.exe
	
	ECHO.
	ECHO ABORTING: Please ensure vpatch.exe is present in the folder
	
	PAUSE

    EXIT
  )

  REM Get current filesize 
  FOR /F %%A in ("00.dat") DO SET _existingFileSize=%%~zA
  
  IF !_originalFileSize! NEQ !_existingFileSize! (

    ECHO.
    ECHO ABORTING: The game script has already been patched by something else

    PAUSE

    EXIT

  ) ELSE (
  
    REM Get patching!
    VPatch.exe 00.dat 00.dat.patched

  )

)

REM If patched file created
IF EXIST "00.dat.patched" (

  REM Get new patched filesize 
  FOR /F %%A in ("00.dat.patched") DO SET _newFileSize=%%~zA
  
  IF !_targetFileSize! NEQ !_newFileSize! (

    ECHO.
    ECHO ABORTING: There was an unknown error while patching

    PAUSE

    EXIT

  ) ELSE (

		ECHO Patching script... SUCCESS!

		REN 00.dat 00.dat.backup

		REM If backup renamed successfully
		IF EXIST "00.dat.patched" (

		ECHO Backing up original file... SUCCESS!    

		REN 00.dat.patched 00.dat

		REM If patched file renamed successfully
		IF EXIST "00.dat" (

		  ECHO Rename patched file... SUCCESS!    
		  ECHO.
		  ECHO Patch applied successfully!
		  ECHO.

		) ELSE (

		  ECHO ERROR: There was a problem renaming the new script

		)

		) ELSE (

		ECHO ERROR: There was a problem backing up the original script

		)
  
  )

)

PAUSE

EXIT